#include <iostream>
#include <map>
#include <vector>


class generic_name_item
{
public:
    virtual ~generic_name_item() = default;
};


class generic_name
{
private:
    std::vector<generic_name_item*> vector_of_name_items;
public:
    void add_name_item(generic_name_item * i)
    {
        vector_of_name_items.push_back(i);
    }
    ~generic_name()
    {
        for(auto x:vector_of_name_items) delete x;
    }
};


class string_literal: public generic_name_item
{
private:
    const char * my_literal;
public:
    string_literal(const char * l): my_literal{l}
    {
        std::cout << "creating string_literal " << this << "\n";
    }

    virtual ~string_literal()
    {
        std::cout << "destroying string_literal " << this << "\n";
    }
};

class identifier_literal: public generic_name_item
{
private:
    const char * my_identifier;
public:
    identifier_literal(const char * l): my_identifier{l}
    {
        std::cout << "creating identifier_literal " << this << "\n";
    }
    virtual ~identifier_literal()
    {
        std::cout << "destroying identifier literal " << this << "\n";
    }
};

class signature
{

};

class machine
{
private:

public:
    machine()
    {
        std::cout << "creating a machine " << this << "\n";
    }
    ~machine()
    {
        std::cout << "destroying a machine\n";
    }
};


#ifdef _WIN32
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT
#endif

extern "C" DLLEXPORT void *chomik_create_generic_name(void *m)
{
    generic_name *gn=new generic_name();
    std::cout << "created generic name " << gn << "\n";
    return gn;
}

extern "C" DLLEXPORT void *chomik_create_string_literal(void * ptr)
{
    std::cout << "create a string literal " << static_cast<const char *>(ptr) << "\n";
    return new string_literal(static_cast<const char *>(ptr));
}

extern "C" DLLEXPORT void *chomik_create_identifier_literal(void * ptr)
{
    std::cout << "create an identifier literal " << static_cast<const char *>(ptr) << "\n";
    return new identifier_literal(static_cast<const char *>(ptr));
}

extern "C" DLLEXPORT void chomik_generic_name_add_name_item(void *gn, void *i)
{
    std::cout << "add name item " << i << " to the generic name " << gn << "\n";
    static_cast<generic_name*>(gn)->add_name_item(static_cast<generic_name_item*>(i));
}


extern "C" DLLEXPORT void chomik_execute_variable_value(void * m, void *gn)
{
    std::cout << "execute variable value\n";



}

extern "C" DLLEXPORT void chomik_destroy_generic_name(void *m, void *gn)
{
    std::cout << "delete generic name " << gn << "\n";
    delete static_cast<generic_name*>(gn);
}


extern "C" DLLEXPORT void *chomik_create_machine(void) {
    machine * m = new machine();
    std::cout << "created machine " << m << "\n";
    return m;
}

extern "C" DLLEXPORT void chomik_destroy_machine(void * m) {
    std::cout << "now delete machine " << m << "\n";
    delete static_cast<machine*>(m);
}


extern "C" int execute_chomik_code(void);

int main()
{
    execute_chomik_code();
    return 0;
}
